<?php
/*
Plugin Name: WordPress AutoLink
Plugin URI: http://rudd-o.com/projects/wp-autolink/
Description: Lets you break free from long, absolute URLs in your blog — <a href="http://rudd-o.com/projects/wp-autolink/wp-autolink-usage/">Usage instructions</a>
Version: 0.4.0
Author: Manuel Amador (Rudd-O)
Author URI: http://rudd-o.com/
*/

/*  Copyright 2005,2006  Manuel Amador

Derivative work from bsuite, written by Casey Bisson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* TODO
maybe blog: para paginas a partir del blog, y home: para paginas a partir del home
maybe enhance autolink to support {post:}-type links
make post: work on embedded javascript events
*/

require_once(dirname(__FILE__)."/tagmogrify/tagmogrify.php");

/* start defines */

$autolink_recognized_html_attributes = array("href","src","cite");
$autolink_recognized_js_attributes = array("onclick","onfocus","onblur","onmouseover","onmouseout","onchange","ondblclick");

/* end defines */


#this may be useful in the short-term future
#$path = plugin_basename(__FILE__); <- for including the mogrify php file


/* the code for displaying warnings to the user in the post editor */
/* this code is shared with autolink but namespaced to prevent clashes */

$autolink_warnings = "";
$autolink_warnings_displayed = false;

function autolink_warning_footer() { global $autolink_warnings; echo $autolink_warnings; }
function autolink_display_warning($warning_id,$title,$contents) {
	global $autolink_warnings;
	$autolink_warnings .= "
	<div id='$warning_id' class='updated fade-ff0000'><p><strong>".$title.".</strong> ".$contents."</p></div>
	";
	$autolink_warnings .= '<script>';
	$autolink_warnings .= "var m = document.getElementById('$warning_id');";
	$autolink_warnings .= "var ps = document.getElementById('poststuff');";
	$autolink_warnings .= "ps.insertBefore(m,ps.firstChild);";
	$autolink_warnings .= '</script>';

	global $autolink_warnings_displayed;
	if (!$autolink_warnings_displayed) {
		add_action('admin_footer', 'autolink_warning_footer');
		$autolink_warnings_displayed = true;
	}
}

/* end admin communication code */

/* start utility functions */

/* I UNDERSTAND what's the purpose of this function.  I just don't understand why you guys (WP devels) NEEDED to place the content_edit_pre filter *after* this piece of shit code.  content_edit_pre is useless for this very reason.  */

function autolink_unhtmlspecialchars ($content) {
	$trans = get_html_translation_table(HTML_SPECIALCHARS);
	$trans = array_flip($trans);
	return strtr($content, $trans);
}

function autolink_undo_format_to_edit_shitload($content) {
	$richedit = ( 'true' == get_user_option('rich_editing') ) ? true : false;
	if (! $richedit ) $content = autolink_unhtmlspecialchars($content);
	return $content;
} function autolink_uftes($content) { return autolink_undo_format_to_edit_shitload($content); }

function autolink_redo_format_to_edit_shitload($content) {
	$richedit = ( 'true' == get_user_option('rich_editing') ) ? true : false;
	if (! $richedit ) $content = htmlspecialchars($content);
	return $content;
} function autolink_rftes($content) { return autolink_redo_format_to_edit_shitload($content); }

function autolink_get_post_permalink($handle) {

	global $wpdb;

	if (intval($handle)."" === $handle) { /* we have a numeric post link */
		$sql = "SELECT ID FROM $wpdb->posts WHERE ID=$handle limit 1;";
	} else { /* we have a text post link */
		$handle = $wpdb->escape($handle);
		$sql = "SELECT ID FROM $wpdb->posts WHERE post_name='$handle' limit 1;";
	}
	/* to verify its existence in the database */
	$post_id = $wpdb->get_var( $sql );
	if ($post_id) {
		return array($post_id,get_permalink($post_id));
	}

}

function autolink_get_content_url($handle,$minusslash=false) {

	if (!$handle && $minusslash) { return get_settings("fileupload_url"); }
	return get_settings("fileupload_url") . "/" . $handle;

}

function autolink_id_to_slug($postid) {
	global $wpdb;
	$sql = "SELECT post_name FROM $wpdb->posts WHERE ID=$handle limit 1;";
	/* to verify its existence in the database */
	$slug = $wpdb->get_var( $sql );
	if ($slug) return $slug;
	return $postid;
}

function autolink_get_post_shortcut_from_permalink($querystring) {
	$post_shortcut = null;
	$postid = url_to_postid($querystring);
	if ($postid) {
		$s = autolink_id_to_slug($postid);
		$post_shortcut = "post:$s";
	}
	return $post_shortcut;
}

$autolink_entity_manifest = file_get_contents(dirname(__FILE__)."/entity-manifest.txt");
$autolink_entity_manifest = 
preg_replace("/<!--.+?-->/s","",$autolink_entity_manifest);
$autolink_entity_manifest =
preg_replace("/ --.+?--/s","",$autolink_entity_manifest);
$autolink_entity_manifest = '<!DOCTYPE chapter SYSTEM "/just/a/test.dtd" [' . "\n" . $autolink_entity_manifest . "]>\n";

function autolink_simple_mogrifier_factory($function_name,$mogrificator_type) {
	global $autolink_entity_manifest;
	$mogrificator_type = "add_{$mogrificator_type}_mogrificator";
	$m = new TagMogrifier(get_settings('blog_charset'),$fatal_errors=false,$entity_declarations=$autolink_entity_manifest);
	$m->$mogrificator_type($function_name);
	return $m;
}

/* end utility functions */

/* start rendering routines post:, content: -> http://... */

function autolink_render_html_post_links(&$attribute,$titles=true) {

	$attrvalue = $attribute->nodeValue;

	if (substr($attrvalue,0,strlen('post:')) == "post:") {
		/* we have a post link */
		$handle = substr($attrvalue,strlen('post:'),strlen($attrvalue));
		
		$splits = explode("#",$handle,2);
		$handle = $splits[0];
		if (count($splits) == 2) { /* there WAS an anchor */ $anchor = $splits[1];}
		else { $anchor = null; }

		list($post_id,$permalink) = autolink_get_post_permalink($handle);

		if ($permalink) {
			$attrvalue = apply_filters('the_permalink', $permalink );
			if ($anchor) {
				$attrvalue .= "#" . $anchor;
			}
			$tag = $attribute->parentNode;
			if (strtolower($attribute->nodeName) == "href" && !$tag->getAttribute("title") && $titles == true) { /* we only autofill the title if it's an a href link and it already does not have a title and if titles were explicitly requested */
				$title = get_the_title($post_id);
				trigger_error("AutoLink render links: setting title: ".$title,E_USER_NOTICE);
 				$tag->setAttribute("title",$title);
				$disp = $tag->getAttribute("title");
				trigger_error("AutoLink render links: title set: ".$disp,E_USER_NOTICE);
			}
		}
	}

	trigger_error("AutoLink render links: modifying: ".$attribute->nodeValue,E_USER_NOTICE);
	$attribute->nodeValue = htmlspecialchars($attrvalue);
	trigger_error("AutoLink render links: new value: ".$attribute->nodeValue,E_USER_NOTICE);

}

function autolink_render_html_post_links_notitles(&$attribute) { return autolink_render_html_post_links($attribute,$titles=false); }

function autolink_render_html_content_links(&$attribute) {

	$attrvalue = $attribute->nodeValue;

	if (substr($attrvalue,0,strlen('content:')) == "content:") {
		/* we have a content link */
		$handle = substr($attrvalue,strlen('content:'),strlen($attrvalue));
		$attrvalue = autolink_get_content_url($handle);
	}

	trigger_error("AutoLink render content links: modifying: ".$attribute->nodeValue,E_USER_NOTICE);
	$attribute->nodeValue = htmlspecialchars($attrvalue);
	trigger_error("AutoLink render content links: new value: ".$attribute->nodeValue,E_USER_NOTICE);

}

function autolink_render_js_content_links(&$attribute) {

	$attrvalue = $attribute->nodeValue;

	$attrvalue = str_replace("'content:", "'" . autolink_get_content_url("") , $attrvalue);
	$attrvalue = str_replace("\"content:", "\"" . autolink_get_content_url("") , $attrvalue);
	
	trigger_error("AutoLink render js links: modifying: ".$attribute->nodeValue,E_USER_NOTICE);
	$attribute->nodeValue = htmlspecialchars($attrvalue);
	trigger_error("AutoLink render js links: new value: ".$attribute->nodeValue,E_USER_NOTICE);

}

function autolink_render($content,$for_editing) {

	global $autolink_recognized_html_attributes,$autolink_recognized_js_attributes;

	// html post links
	if ($for_editing) $m1 = autolink_simple_mogrifier_factory("autolink_render_html_post_links_notitles","attribute");
	else $m1 = autolink_simple_mogrifier_factory("autolink_render_html_post_links","attribute");
	foreach ($autolink_recognized_html_attributes as $attribute) {
		$m1->add_attribute_match(null,"istring:$attribute","regexp:/^post:/");
	}

	// html content links
	$m2 = autolink_simple_mogrifier_factory("autolink_render_html_content_links","attribute");
	foreach ($autolink_recognized_html_attributes as $attribute) {
		$m2->add_attribute_match(null,"istring:$attribute","regexp:/^content:/");
	}

	// js content links
	$m3 = autolink_simple_mogrifier_factory("autolink_render_js_content_links","attribute");
	foreach ($autolink_recognized_js_attributes as $attribute) {
		$m3->add_attribute_match(null,"istring:$attribute","regexp:/'content:/");
		$m3->add_attribute_match(null,"istring:$attribute","regexp:/\"content:/");
	}

	$newcontent = $m3->run($m2->run($m1->run($content)));
	$warning = "<!-- AutoLink could not process this post because it has invalid HTML.  Please fix it. -->";
	if ($newcontent === false) {
		if ($for_editing) {
			// show a warning, dood
			autolink_display_warning("autolink-warning",__('AutoLink cannot process this post'),sprintf(__('This post contains invalid HTML.  AutoLink cannot process posts with invalid HTML.  Please fix it, and then hit %1$s.'), __("Save and Continue Editing")));
		}
		return $content;
	}
	return $newcontent;

}

function autolink_render_for_display($content) { return autolink_render($content,$for_editing=false); }
function autolink_render_for_editing($content) { return autolink_render($content,$for_editing=true); }

/* end rendering routines post:, content: -> http://... */

/* start simplification routines http://... -> content:, post: */

function autolink_simplify_html_post_links ($attribute) {

	$attrvalue = $attribute->nodeValue;
	
	/* we save the anchor */
	$splits = explode("#",$attrvalue,2);
	if (count($splits) == 1) {
		$presumed_permalink = $attrvalue;
		$anchor = null;
	} else list($presumed_permalink,$anchor) = $splits;

	$shortcut = autolink_get_post_shortcut_from_permalink($presumed_permalink);
	if ($shortcut) {
		$attrvalue = $shortcut;
		/* if we had an anchor, we append it to the post shortcut link */
		if ($anchor) $attrvalue .= "#" . $anchor;

		/* andwe finally store the node value */
		trigger_error("AutoLink simplify posts: modifying: ".$attribute->nodeValue,E_USER_NOTICE);
		$attribute->nodeValue = $attrvalue;
		trigger_error("AutoLink simplify posts: new value: ".$attribute->nodeValue,E_USER_NOTICE);
	}

}

function autolink_simplify_html_content_links ($attribute) {

	$attrvalue = $attribute->nodeValue;

	$content_url = autolink_get_content_url("");

	if (substr($attrvalue,0,strlen($content_url)) == $content_url) {
		/* we have a content link */
		$handle = substr($attrvalue,strlen($content_url),strlen($attrvalue)); /* which should give me the rest */
		$attrvalue = "content:" . $handle;
	} elseif ($attrvalue == $content_url) {
		$attrvalue = "content:";
	}

	$content_url = autolink_get_content_url("",$minusslash=true);

	// in case they forget the trailing slash
	if ($attrvalue == $content_url) {
		$attrvalue = "content:";
	}

	trigger_error("AutoLink simplify content links: modifying: ".$attribute->nodeValue,E_USER_NOTICE);
	$attribute->nodeValue = htmlspecialchars($attrvalue);
	trigger_error("AutoLink simplify content links: new value: ".$attribute->nodeValue,E_USER_NOTICE);

}

function autolink_simplify_js_content_links(&$attribute) {

	$attrvalue = $attribute->nodeValue;

	$attrvalue = str_replace("'" . autolink_get_content_url("") , "'content:" , $attrvalue);
	$attrvalue = str_replace("\"" . autolink_get_content_url("") , "\"content:" , $attrvalue);
	// in case they forget the trailing slash
	$attrvalue = str_replace("'" . autolink_get_content_url("",$minusslash=true) . "'" , "'content:'" , $attrvalue);
	$attrvalue = str_replace("\"" . autolink_get_content_url("",$minusslash=true) . "\"" , "\"content:\"" , $attrvalue);
	
	trigger_error("AutoLink simplify js links: modifying: ".$attribute->nodeValue,E_USER_NOTICE);
	$attribute->nodeValue = $attrvalue;
	trigger_error("AutoLink simplify js links: new value: ".$attribute->nodeValue,E_USER_NOTICE);

}

function autolink_simplify($content) {

	global $autolink_recognized_html_attributes,$autolink_recognized_js_attributes;

	// html post links
	$m1 = autolink_simple_mogrifier_factory("autolink_simplify_html_post_links","attribute");
	foreach ($autolink_recognized_html_attributes as $attribute) {
		$m1->add_attribute_match(null,"istring:$attribute",null);
	}

	// html content links
	$m2 = autolink_simple_mogrifier_factory("autolink_simplify_html_content_links","attribute");
	foreach ($autolink_recognized_html_attributes as $attribute) {
		$m2->add_attribute_match(null,"istring:$attribute",null);
	}

	// js content links
	$m3 = autolink_simple_mogrifier_factory("autolink_simplify_js_content_links","attribute");
	foreach ($autolink_recognized_js_attributes as $attribute) {
		$m3->add_attribute_match(null,"istring:$attribute",null);
	}

	$newcontent = $m3->run($m2->run($m1->run($content)));
	if ($newcontent === false) return $content;
	return $newcontent;

}

/* end simplification routines http://... -> content:, post: */

/* start setup */

function autolink_filter_content($content) { return autolink_render_for_display($content); }
function autolink_filter_excerpt($content) { return autolink_render_for_display($content); }
function autolink_filter_excerpt_rss($content) { return autolink_render_for_display($content); }
function autolink_filter_content_save_pre($content) { return addslashes(autolink_simplify(stripslashes($content))); }
function autolink_filter_excerpt_save_pre($content) { return addslashes(autolink_simplify(stripslashes($content))); }
function autolink_filter_format_to_edit($content) {
	$content = autolink_uftes($content);
	$content = autolink_render_for_editing($content);
	$content = autolink_rftes($content);
	/* first undo the format_to_edit, then pass through the renderer, then redo the format_to_edit munging */
	/* FIXME there's gotta be a better way to do this! And I don't mean that in a Perlish way! */
	return $content;
}

add_filter('the_content', 'autolink_filter_content');
add_filter('the_excerpt', 'autolink_filter_excerpt');
add_filter('the_excerpt_rss', 'autolink_filter_excerpt_rss');
add_filter('content_save_pre', 'autolink_filter_content_save_pre',0);
add_filter('excerpt_save_pre', 'autolink_filter_excerpt_save_pre',0);
add_filter('content_edit_pre', 'autolink_filter_format_to_edit',0);

/* end setup */

?>
